unit ayaclkf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, Registry,ShellApi,
  aboutf, CoolTrayIcon;

type
  TAyaClockForm = class(TForm)
    BasePnl: TPanel;
    Timer1: TTimer;
    TimeST: TStaticText;
    MemST: TStaticText;
    Pmn: TPopupMenu;
    mnQuit: TMenuItem;
    mnDmy: TMenuItem;
    mnFont: TMenuItem;
    mnPosition: TMenuItem;
    mnAbout: TMenuItem;
    mnLeftTop: TMenuItem;
    mnLeftBottom: TMenuItem;
    mnRightTop: TMenuItem;
    mnRightBottom: TMenuItem;
    FontDlg: TFontDialog;
    mnDmy2: TMenuItem;
    mnAnyPos: TMenuItem;
    LB: TLabel;
    DayST: TStaticText;
    cLB: TLabel;
    Shape1: TShape;
    CoolTrayIcon1: TCoolTrayIcon;
    mnIgnoreTB: TMenuItem;
    mnAdjustTime: TMenuItem;
    mnAlwaysTop: TMenuItem;
    mnComma: TMenuItem;
    mnSecond: TMenuItem;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mnQuitClick(Sender: TObject);
    procedure mnFontClick(Sender: TObject);
    procedure mnAboutClick(Sender: TObject);
    procedure mnPosChangeClick(Sender: TObject);
    procedure ACMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ACSTMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ACSTMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnIgnoreTBClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnAdjustTimeClick(Sender: TObject);
    procedure PmnPopup(Sender: TObject);
    procedure CoolTrayIcon1Click(Sender: TObject);
    procedure mnAlwaysTopClick(Sender: TObject);
    procedure mnCommaClick(Sender: TObject);
    procedure mnSecondClick(Sender: TObject);
    //procedure mnSecondClick(Sender: TObject);
  private
    { Private 錾 }
  protected
    { protected 錾 }
    sx,sy,PosType : integer;
    FMaxPhysMemStr : string;
    FNowOp,
    NowMoving : boolean;
    qCounter : DWORD;
    procedure SetupTimeAndMem;
    procedure SetPos;
    procedure ResetPosition(newpos:integer);
    procedure Adjust;
    procedure ChangeFormXY(C:TCOntrol; var x,y:integer);
    procedure LoadReg;
    function  CheckSE:boolean;
    procedure SetNowOp(ANowOp:boolean);
    function  GetStayOnTop:boolean;
    procedure SetStayOnTop(AValue:boolean);
    function  GetComma:boolean;
    procedure SetComma(AValue:boolean);
    function  GetSecond:boolean;
    procedure SetSecond(AValue:boolean);
  public
    { Public 錾 }
    property  NowOp : boolean read FNowOp write SetNowOp;
    property  StayOnTop : boolean read GetStayOnTop write SetStayOnTop;
    property  Comma : boolean read GetComma write SetComma;
    property  Second : boolean read GetSecond write SetSecond;
  end;

var
  AyaClockForm: TAyaClockForm;

implementation

{$R *.DFM}

const
  defPosType = 1; // 
  RegRoot = 'Software\MarleySoft\AyaClock';
  SecPosition = 'Position';
  KeyType = 'Type';
  defType = defPosType;
  KeyX = 'X';
  defX = 0;
  KeyY = 'Y';
  defY = 0;
  SecFont = 'Font';
  KeyName = 'Name';
  defName = 'lr oSVbN';
  KeySize = 'Size';
  defSize = 9;
  KeyEffect = 'Effect';
  defEffect = 0;
  feBold = $01; feItalic = $02; feUnderLine = $04; feStrikeOut = $08;
  KeyColor = 'Color';
  defColorVal = clWindowText;
  SecOption = 'Option';
  KeyIgnoreTaskBar = 'IgnoreTaskBar';
  defIgnoreTaskBar = FALSE;
  KeyAlwaysTop = 'AlwaysTop';
  defAlwaysTop = FALSE;
  KeyComma = 'Comma';
  defComma = false;
  KeySecond = 'Second';
  defSecond = false;

type
  TGlobalMemoryStatusEx = packed record
    dwLength,
    dwMemoryLoad : DWORD;
    ullTotalPhys,
    ullAvailPhys,
    ullTotalPageFile,
    ullAvailPageFile,
    ullTotalVirtual,
    ullAvailVirtual,
    ullAvailExtendedVirtual : INT64; // {ȂUINT64B
  end;

var
  GlobalMemoryStatusEx : function(var GMSE : TGlobalMemoryStatusEx):BOOL; stdcall;
  HKernel32 : THandle;

procedure TAyaClockForm.FormCreate(Sender: TObject);
begin
  // ftHgݒ
  PosType:=defPosType; NowMoving:=false;
  qCounter:=0;
  FNowOp:=false;
  // read reg
  LoadReg;
  // 
  Adjust;
  ResetPosition(PosType);
  //
  SetupTimeAndMem;
end;

procedure TAyaClockForm.LoadReg;
var
  ini : TRegIniFile;
  w : integer;
  ms : TGlobalMemoryStatusEx;
begin
  ini:=TRegIniFile.Create(RegRoot);
  try
    mnIgnoreTB.Checked:=ini.ReadBool(SecOption,KeyIgnoreTaskBar,defIgnoreTaskBar);
    PosType:=ini.ReadInteger(SecPosition,KeyType,defType);
    IF (PosType<1) OR (PosType>5) THEN PosType:=1;
    CASE PosType OF
      2 : mnLeftBottom.Checked:=true;
      3 : mnRightTop.Checked:=true;
      4 : mnRightBottom.Checked:=true;
      5 : mnAnyPos.Checked:=true;
    END;
    left:=ini.ReadInteger(SecPosition,KeyX,defX);
    top:=ini.ReadInteger(SecPosition,KeyY,defY);
    Font.Name:=ini.ReadString(SecFont,KeyName,defName);
    Font.Size:=ini.ReadInteger(SecFont,KeySize,defSize);
    Font.Color:=StringToColor(Ini.ReadString(SecFont,KeyColor,ColorToString(defColorVal)));
    Font.Style:=[];
    w:=ini.ReadInteger(SecFont,KeyEffect,defEffect);
    IF (w AND feBold)<>0 THEN Font.Style:=Font.Style+[fsBold];
    IF (w AND feItalic)<>0 THEN Font.Style:=Font.Style+[fsItalic];
    IF (w AND feUnderLine)<>0 THEN Font.Style:=Font.Style+[fsUnderLine];
    IF (w AND feStrikeOut)<>0 THEN Font.Style:=Font.Style+[fsStrikeOut];
    StayOnTop:=ini.ReadBool(SecOption,KeyAlwaysTop,defAlwaysTop);
    Comma:=ini.ReadBool(SecOption,KeyComma,defComma);
    Second:=ini.ReadBool(SecOption,KeySecond,defSecond);
  finally
    ini.free;
  end;
  // 1GB Over Check -> 7\ , L\̏ꍇ̂߂ɎO`FbN
  FillChar(ms,sizeof(ms),0);
  ms.dwLength:=sizeof(TGlobalMemoryStatusEx);
  GlobalMemoryStatusEx(ms);
  FMaxPhysMemStr := IntToStr(ms.ullTotalPhys div 1024);
end;

procedure TAyaClockForm.SetupTimeAndMem;
var
  ms : TGlobalMemoryStatusEx;
  wc : comp; // Format֐v̂...
begin
  DayST.caption:=FormatDateTime('mm/dd',date);
  IF Second THEN
    TimeST.caption:=FormatDateTime('hh:nn:ss',time)
  ELSE
    TimeST.caption:=FormatDateTime('hh:nn',time);
  //TimeST.caption:=FormatDateTime('hh:nn',time);
  FillChar(ms,sizeof(ms),0);
  ms.dwLength:=sizeof(TGlobalMemoryStatusEx);
  GlobalMemoryStatusEx(ms);
  IF Comma THEN BEGIN
    wc:=ms.ullAvailPhys div 1024;
    MemST.caption:=Format('%.n',[wc])+'KB';
  END ELSE
    MemST.caption:=IntToStr(ms.ullAvailPhys div 1024)+'KB';
end;

procedure TAyaClockForm.SetPos;
var
  w,h : integer;
  r : TRect;
  bs : TAppBarData;
  // SHAppBarMessagegă^XNo[̈ʒu擾͔̂
  // ߂ǂ̂ŁAPɃ^XNo[̃TCYe擾B
  // [AABM_QUERYPOŚAAvŏɗオƂɂ
  // ^XNo[̈ʒuԂB܂ǍʒuςĂAύX
  // ʒu𔽉fȂȂǂ̕sAȂƂ2000+SP1ł͍݂B
  procedure GetAppBarRect;
  begin
    //FillChar(bs,sizeof(bs),0);
    //bs.cbSize:=sizeof(bs);
    WITH bs DO BEGIN
      uEdge:=UINT(-1); // K[h
      hWnd:=FindWindow('Shell_TrayWnd',nil); // ^XNo[̃nh`
      IF hwnd=0 THEN Exit; // ^XNo[̃nhȂ
      IF NOT GetWindowRect(hWnd,rc) THEN Exit; // TCYƂȂ
      // ^XNo[̈ʒu𔻒
      IF rc.right<w THEN  // Ȃ̂̓^XNo[ɂƂ̂
        uEdge := ABE_LEFT
      ELSE IF rc.left>w THEN // Ȃ̂̓^XNo[EɂȂƂ̂
        uEdge := ABE_RIGHT
      ELSE IF rc.bottom<h THEN
        uEdge := ABE_TOP
      ELSE
        uEdge := ABE_BOTTOM;
    END;
  end;
begin
  // ʃTCY擾
  r.left:=0; r.right:=Screen.Width;
  r.top:=0; r.bottom:=Screen.Height;
  // ^XNo[̏擾
  IF NOT mnIgnoreTB.Checked THEN BEGIN
    w:=Screen.Width div 2; h:=Screen.height div 2;
    GetAppBarRect;
    // ^XNo[̈ʒu𔽉f
    CASE bs.uEdge OF
      ABE_BOTTOM:  // 
        r.bottom:=bs.rc.top;
      ABE_LEFT:    // 
        r.left:=bs.rc.right;
      ABE_RIGHT:   // E
        r.right:=bs.rc.left;
      ABE_TOP:     // 
        r.top:=bs.rc.bottom;
    END;
  END;
  // ݒ
  CASE PosType OF
    1 : // 
      BEGIN
        left:=r.Left; top:=r.top;
      END;
    2 : // 
      BEGIN
        left:=r.left; top:=r.bottom-Height;
      END;
    3 : // E
      BEGIN
        left:=r.right-Width; top:=r.top;
      END;
    4 : // E
      BEGIN
        left:=r.right-Width; top:=r.bottom-Height;
      END;
    5 : // Cӂ̏ꏊ
      BEGIN
        IF left<r.left THEN left:=r.left;
        IF (left+width)>r.right THEN left:=r.right-width;
        IF top<r.top THEN top:=r.top;
        IF (top+height)>r.bottom THEN top:=r.bottom-height;
      END;
  END;
end;

procedure TAyaClockForm.ResetPosition(newpos:integer);
var
  ini : TRegIniFile;
begin
  IF (newpos<1) OR (5<newpos) THEN Exit;
  PosType:=newpos;
  SetPos;
  // write reg
  ini:=TRegIniFile.Create(RegRoot);
  try
    ini.WriteInteger(SecPosition,KeyType,postype);
    ini.WriteInteger(SecPosition,KeyX,left);
    ini.WriteInteger(SecPosition,KeyY,top);
  finally
    ini.free;
  end;
end;

procedure TAyaClockForm.Adjust;
var
  c,d : char;
  w,w0,w1,h,cn,i : integer;
  n4,n6 : integer;
  tm : TTextMetric;
begin
  // e̍ő啝vZ
  w:=0; d:='0';
  FOR c:='0' TO '9' DO BEGIN
    LB.caption:=c;
    IF LB.width>w THEN BEGIN w:=LB.width; d:=c; END;
  END;
  LB.caption:=d+d+d+d;
  n4:=LB.Width;  // S̍ő啝(MM/DD or hh:mm Ŏgp)
  LB.caption:=d+d+d+d+d+d;
  n6:=LB.Width;  // U̍ő啝(hh:mm:ss or memoryKBŎgp)
  cLB.Font:=Font;
  cLB.Font.Style:=[];
  cLB.caption:=d;
  w:=cLB.width;  // ]̕(̒̍ő啝)
  // 
  GetTextMetrics(LB.canvas.handle,tm);
  h:=tm.tmAscent; // tmDecent͂Ȃ:-
  IF Comma THEN h:=h+tm.tmDescent; // , \̎...
  // 
  LB.caption:='/';
  DayST.SetBounds(BasePnl.BevelWidth+2,3,LB.Width+n4,h);
  // 
  IF Second THEN BEGIN
    LB.Caption:='::'; w0:=n6+LB.Width;  // hh:mm:ss̒
  END ELSE BEGIN
    LB.Caption:=':'; w0:=n4+LB.Width;   // hh:mm̒
  END;
  //LB.Caption:=':'; w0:=n4+LB.Width;   // hh:mm̒
  TimeST.SetBounds(DayST.Left+DayST.Width+w,3,w0,h);
  // 
  LB.Caption:='KB';
  IF Comma THEN BEGIn
    // , ŋ؂ꍇ
    cn := (Length(FMaxPhysMemStr)-1) div 3;
    FOR i:=1 TO cn DO LB.Caption:=','+LB.Caption;
  END;
  w1:=Lb.Width; // ܂(),KB̒̕
  LB.Caption:='';
  FOR i:=1 TO Length(FMaxPhysMemStr) DO
    LB.Caption:=LB.Caption+d;
  w1:=w1+LB.width; // TCY̌
  MemST.SetBounds(TimeST.Left+TimeST.Width+w,3,w1,h);
  // pl
  BasePnl.SetBounds(1,1,MemST.Left+MemST.width+2+BasePnl.BevelWidth,h+4+BasePnl.BevelWidth*2);
  // Shape
  Shape1.SetBounds(0,0,BasePnl.Width+2, BasePnl.Height+2);
  // tH[
  ClientHeight:=Shape1.height;
  ClientWidth:=Shape1.width;
end;

procedure TAyaClockForm.Timer1Timer(Sender: TObject);
begin
  SetPos; // ScreeñTCYύXɑΉ
  Inc(qCounter);
  IF 1000<=(qCounter*Timer1.Interval) THEN BEGIN
    qCounter:=0;
    SetupTimeAndMem;
  END;
end;

procedure TAyaClockForm.mnQuitClick(Sender: TObject);
begin
  Close;
end;

procedure TAyaClockForm.mnFontClick(Sender: TObject);
var
  ini : TRegIniFile;
  w : integer;
begin
  NowOp:=TRUE;
  try
    // font
    FontDlg.Font:=Font;
    IF FontDlg.Execute THEN BEGIN
      Font:=FontDlg.Font;
      Adjust;
      ResetPosition(PosType);
      // write reg
      ini:=TRegIniFile.Create(RegRoot);
      try
        ini.WriteString(SecFont,KeyName,Font.Name);
        ini.WriteInteger(SecFont,KeySize,Font.Size);
        ini.WriteString(SecFont,KeyColor,ColorToString(Font.Color));
        w:=0;
        IF fsBold in Font.Style THEN w:=w OR feBold;
        IF fsItalic in Font.Style THEN w:=w OR feItalic;
        IF fsUnderLine in Font.Style THEN w:=w OR feUnderLine;
        IF fsStrikeOut in Font.Style THEN w:=w OR feStrikeOut;
        ini.WriteInteger(SecFont,KeyEffect,w);
      finally
        ini.free;
      end;
    END;
  finally
    NowOp:=FALSE;
  end;
end;

procedure TAyaClockForm.mnAboutClick(Sender: TObject);
begin
  // about
  NowOp:=TRUE;
  try
    AboutForm.ShowModal;
  finally
    NowOp:=FALSE;
  end;
end;

procedure TAyaClockForm.mnPosChangeClick(Sender: TObject);
begin
  //
  WITH (Sender as TMenuItem) DO BEGIN
    Checked:=true;
    ResetPosition(Tag);
  END;
end;

procedure TAyaClockForm.ChangeFormXY(C:TControl; var x,y:integer);
var
  tp : TPoint;
begin
  tp.x:=x; tp.y:=y;
  tp:=C.ClientToScreen(tp);
  x:=tp.x; y:=tp.y;
end;

procedure TAyaClockForm.ACMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  IF (PosType<>5) OR (Button<>mbLeft) THEN Exit;
  //
  NowMoving:=true;
  ChangeFormXY(Sender as TControl,x,y);
  sx:=x; sy:=y;
end;

procedure TAyaClockForm.ACSTMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  IF NOT NowMoving THEN Exit;
  //
  ChangeFormXY(Sender as TControl,x,y);
  SetBounds(left+(x-sx),top+(y-sy),width,height);
  sx:=x; sy:=y;
end;

procedure TAyaClockForm.ACSTMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  ini : TRegIniFile;
begin
  IF NOT NowMoving THEN Exit;
  NowMoving:=false;
  //
  ini:=TRegIniFile.Create(RegRoot);
  try
    ini.WriteInteger(SecPosition,KeyX,left);
    ini.WriteInteger(SecPosition,KeyY,Top);
  finally
    ini.free;
  end;
end;

procedure TAyaClockForm.mnIgnoreTBClick(Sender: TObject);
var
  ini : TRegIniFile;
begin
  mnIgnoreTB.Checked:=NOT mnIgnoreTB.Checked;
  //
  ini:=TRegIniFile.Create(RegRoot);
  try
    ini.WriteBool(SecOption,KeyIgnoreTaskBar,mnIGnoreTB.Checked);
  finally
    ini.free;
  end;
end;

procedure TAyaClockForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  x,y:integer;
begin
  IF (KEY=VK_RETURN) AND (Shift=[ssCtrl]) THEN BEGIN
    KEY:=0;
    x:=left+width div 2; y:=top+height div 2;
    SetCursorPos(x,y);
    Pmn.Popup(x,y);
  END;
end;

procedure TAyaClockForm.mnAdjustTimeClick(Sender: TObject);
begin
  // ߂ǁ[Ȃ̂ŃRplJ(^^;;
  ShellExecute(Handle, 'OPEN', 'rundll32.exe',
               'shell32.dll,Control_RunDLL Timedate.cpl',
               '', SW_SHOW);
end;

procedure TAyaClockForm.mnAlwaysTopClick(Sender: TObject);
var
  ini : TRegIniFile;
begin
  StayOnTop:=NOT StayOnTop;
  //
  ini:=TRegIniFile.Create(RegRoot);
  try
    ini.WriteBool(SecOption,KeyAlwaysTop,StayOnTop);
  finally
    ini.free;
  end;
end;


// Ԃ킹̌Ă邩ǂ`FbN
function TAyaClockForm.CheckSE:boolean;
var
  Luid : TLargeInteger;
  hToken : THANDLE;
  tpNew,tpSv : TTokenPrivileges;
  dwDmy : DWORD;
begin
  result:=true;
  IF Win32Platform<>VER_PLATFORM_WIN32_NT THEN Exit;
  result:=false;
  IF NOT LookupPrivilegeValue(nil,'SeSystemtimePrivilege',Luid) THEN Exit;
  IF NOT OpenProcessToken(GetCurrentProcess,TOKEN_WRITE OR TOKEN_QUERY,hToken) THEN Exit;
  WITH tpNew DO BEGIN
    PrivilegeCount:=1;
    Privileges[0].Luid:=Luid;
    Privileges[0].Attributes:=SE_PRIVILEGE_ENABLED;
  END;
  result:=AdjustTokenPrivileges(hToken,FALSE,tpNew,sizeof(tpSv),tpSv,dwDmy);
  IF result THEN BEGIN
    result:=(GetLastError=ERROR_SUCCESS);
    AdjustTokenPrivileges(hToken,FALSE,tpSv,sizeof(tpNew),tpNew,dwDmy);
  END;
  CloseHandle(hToken);
end;

procedure TAyaClockForm.PmnPopup(Sender: TObject);
begin
  mnAdjustTime.Enabled:=CheckSE
end;

procedure TAyaClockForm.CoolTrayIcon1Click(Sender: TObject);
begin
  mnAdjustTime.Enabled:=CheckSE
end;

procedure TAyaClockForm.SetNowOp(ANowOp:boolean);
begin
  IF FNowOp=ANowOp THEN Exit;
  FNowOp:=ANowOp;
  IF FNowOp THEN BEGIN
    mnFont.Enabled:=false;
    mnABout.Enabled:=false;
  END ELSE BEGIN
    mnFont.Enabled:=true;
    mnABout.Enabled:=true;
  END;
end;

function  TAyaClockForm.GetStayOnTop:boolean;
begin
  result:=mnAlwaysTop.Checked;
end;

procedure TAyaClockForm.SetStayOnTop(AValue:boolean);
begin
  IF mnALwaysTop.Checked=AValue THEN Exit;
  //
  mnAlwaysTop.Checked:=AValue;
  IF StayOnTop THEN FormStyle:=fsStayOnTop ELSE FormStyle:=fsNormal;
end;

function  TAyaClockForm.GetComma:boolean;
begin
  result:=mnComma.Checked;
end;

procedure TAyaClockForm.SetComma(AValue:boolean);
var
  ini : TRegIniFile;
begin
  IF Comma=AValue THEN Exit;
  mnComma.Checked:=AValue;
  Adjust;
  ResetPosition(PosType);
  Repaint;
  ini:=TRegIniFile.Create(RegRoot);
  try
    ini.WriteBool(SecOption,KeyComma,Comma);
  finally
    ini.free;
  end;
end;

procedure TAyaClockForm.mnCommaClick(Sender: TObject);
begin
  Comma:=NOT Comma;
end;

function  TAyaClockForm.GetSecond:boolean;
begin
  result:=mnSecond.Checked;
end;

procedure TAyaClockForm.SetSecond(AValue:boolean);
var
  ini : TRegIniFile;
begin
  IF Second=AValue THEN Exit;
  mnSecond.Checked:=AValue;
  Adjust;
  ResetPosition(PosType);
  Repaint;
  ini:=TRegIniFile.Create(RegRoot);
  try
    ini.WriteBool(SecOption,KeySecond,Second);
  finally
    ini.free;
  end;
end;

procedure TAyaClockForm.mnSecondClick(Sender: TObject);
begin
  Second:=NOT Second;
end;

function DummyMemFunc(var GMSE:TGlobalMemoryStatusEx):BOOL; stdcall;
var
  ms : TMemoryStatus;
begin
  FillChar(ms,sizeof(ms),0);
  ms.dwLength:=sizeof(TMemoryStatus);
  GlobalMemoryStatus(ms);
  WITH GMSE DO BEGIN
    //dwLength
    dwMemoryLoad     := ms.dwMemoryLoad;
    ullTotalPhys     := ms.dwTotalPhys;
    ullAvailPhys     := ms.dwAvailPhys;
    ullTotalPageFile := ms.dwTotalPageFile;
    ullAvailPageFile := ms.dwAvailPageFile;
    ullTotalVirtual  := ms.dwTotalVirtual;
    ullAvailVirtual  := ms.dwAvailVirtual;
    ullAvailExtendedVirtual := 0; // not support
  END;
  result:=true;
end;

procedure InitMemFunc;
var
  sv : integer;
  p    : TFarProc;
begin
  GlobalMemoryStatusEx:=DummyMemFunc;
  sv:=SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    HKernel32:=LoadLibrary('kernel32.dll');
    IF HKernel32<>0 THEN BEGIN
      p:=GetProcAddress(HKernel32,'GlobalMemoryStatusEx');
      IF p<>nil THEN @GlobalMemoryStatusEx:=p;
    END;
  finally
    SetErrorMode(sv);
  end;
end;

procedure DoneMemFunc;
begin
  IF HKernel32<>0 THEN BEGIN
    FreeLibrary(Hkernel32);
    HKernel32:=0;
  END;
end;

initialization
  InitMemFunc;

finalization
  DoneMemFunc;

end.
